﻿Global MenuPoint:Int

Function DrawASCText(txt:String, xt:Int, yt:Int)
	Local p:Int = 0, c1:Byte = $F, c2:Byte = 0
	Local startX:Int = xt
	ASC_CorrectText(txt)
	While p < txt.Length
	
		'* Color-Tags finden:
		Select Chr(txt[p])
		Case "{"
			If p + 4 <= txt.Length And Chr(txt[p + 3]) = "}" Then
				'* {VB}	je im Bereich $0 bis $F kann 16 Vorder- und	Hintergrundfarben setzen.
				c1 = Int("$" + Chr(txt[p + 1]))	'VG
				c2 = Int("$" + Chr(txt[p + 2]))	'BG
				p:+4
				Continue
			EndIf
		
		'* Symbol Bilden:
		Case "["
			If p + 4 <= txt.Length And Chr(txt[p + 3]) = "]" Then
				'* [YX]	je im Bereich $0 bis $F kann jedes der 256 Tiles adressieren.
				Local a:String = Chr(Int("$" + Chr(txt[p + 1]) + Chr(txt[p + 2])))
				txt = txt[..p + 3] + a + txt[p + 4..]
				p:+3
			EndIf

		'* Zeilenumbruch:
		Case "~n"
			xt = startX
			yt:+1
			p:+1
			Continue
		
		EndSelect
		
		'* Hintergrund mit Füllendem Tile setzten:
		ASC_Color(c2)
		DrawImage(Ascii, xt * TileSize, yt * TileSize, $DB)
		'* Vordergrundzeichen:
		ASC_Color(c1)
		'DrawImage(Ascii, xt * TileSize, yt * TileSize, ASC_CorrectChar(txt[p]))
		DrawImage(Ascii, xt * TileSize, yt * TileSize, txt[p])
		xt:+1
		p:+1
	Wend
	
End Function

Rem
	Nummer von 0 bis 15 entspricht dieser Farbe...
Endrem
Function ASC_Color(c:Int = 0)
	Select c
		Case $0; SetColor(0, 0, 0)			'*0 Schwarz		
		Case $1; SetColor(170, 170, 170)	'*1 Grau (Dunkel)
		Case $2; SetColor(85, 85, 85)		'*2 Grau (Hell)
		Case $3; SetColor(0, 0, 170)		'*3 Blau	(Dunkel)
		Case $4; SetColor(0, 170, 0)		'*4 Grün
		Case $5; SetColor(0, 170, 170)		'*5 Cyan
		Case $6; SetColor(170, 0, 0)		'*6 Rot
		Case $7; SetColor(170, 0, 170)		'*7 Magenta
		Case $8; SetColor(170, 85, 0)		'*8 Braun
		Case $9; SetColor(85, 85, 255)		'*9 Blau (Hell)
		Case $A; SetColor(85, 255, 85)		'*A Grün
		Case $B; SetColor(85, 255, 255)		'*B Cyan
		Case $c; SetColor(255, 85, 85)		'*C Rot
		Case $D; SetColor(255, 85, 255)		'*D Rosa
		Case $E; SetColor(255, 255, 85)		'*E Gelb
		Case $F; SetColor(255, 255, 255)	'*F Weiß

		Default; SetColor(0, 0, 0)
	End Select
End Function

Function MakeVGColor:String(_color:Int)
	Local s:String = Hex(_color)
	Return "{" + s[s.Length - 2..s.Length - 1] + "0}"
EndFunction

Function MakeColor:String(_color:Int)
	Local s:String = Hex(_color)
	Return "{" + s[s.Length - 2..s.Length] + "}"
EndFunction

Function MakeSymbol:String(_symbol:Int)
	Local s:String = Hex(_symbol)
	Return "[" + s[s.Length - 2..s.Length] + "]"
EndFunction

Rem
	Sonderzeichen müssen mit dem richtigem
	Code verschlüsselt werden, sonst gibt
	es leichte Darstellungsfehler.
Endrem
Function ASC_CorrectText(_txt:String Var)
	_txt = _txt.Replace("Ä", "[8E]")
	_txt = _txt.Replace("ä", "[84]")
	_txt = _txt.Replace("Ö", "[99]")
	_txt = _txt.Replace("ö", "[94]")
	_txt = _txt.Replace("Ü", "[9A]")
	_txt = _txt.Replace("ü", "[81]")

	_txt = _txt.Replace("á", "[A0]")
	_txt = _txt.Replace("à", "[85]")
	_txt = _txt.Replace("É", "[90]")
	_txt = _txt.Replace("ê", "[88]")
	_txt = _txt.Replace("è", "[8A]")
	_txt = _txt.Replace("é", "[82]")
	_txt = _txt.Replace("ú", "[A3]")
	_txt = _txt.Replace("ù", "[97]")
	_txt = _txt.Replace("ó", "[A2]")
	_txt = _txt.Replace("ò", "[95]")
	_txt = _txt.Replace("ô", "[93]")
	
	_txt = _txt.Replace("§", "[15]")
	'_txt = _txt.Replace("", "[]")
EndFunction

Rem
	Umlaut/Sonderzeichen-korrektur
	Veraltet - benutze ASC_CorrectText um
	Fehler beim Anzeigen von Symbolen zu
	vermeiden.
EndRem
Function ASC_CorrectChar:Int(char:Int)
	
	'Return char
	If char > $20 Or char < $A5 Then
		Select char
			Case Asc("Ä") ; Return $8E
			Case Asc("ä") ; Return $84
			Case Asc("á") ; Return $A0
			Case Asc("à") ; Return $85
			Case Asc("â") ; Return $83
			Case Asc("É") ; Return $90
			Case Asc("ê") ; Return $88
			Case Asc("è") ; Return $8A
			Case Asc("é") ; Return $82
			Case Asc("Ü") ; Return $9A
			Case Asc("ü") ; Return $81
			Case Asc("ú") ; Return $A3
			Case Asc("ù") ; Return $97
			Case Asc("û") ; Return $96
			Case Asc("Ö") ; Return $99
			Case Asc("ö") ; Return $94
			Case Asc("ó") ; Return $A2
			Case Asc("ò") ; Return $95
			Case Asc("ô") ; Return $93
			Case Asc("§") ; Return $15
			'Case Asc("ß") ; Return $??
			?Debug
				Case Asc(" ") ; Return $F9
			?
			Default Return char
		End Select
	Else
		Return char
	EndIf
End Function

Function Button:Int(_txt:String, _x:Int, _y:Int, _nr:Int, _c1:String, _c2:String = "")
	If _c2 = "" Then _c2 = _c1
	If MenuPoint = _nr Then
		DrawASCText(_c2 + "[1a]" + _txt, _x - 2, _y)
		If KeyHit(KEY_RETURN) Then
			FlushKeys()
			MenuPoint = 0
			Return 1
		Else
			Return 2
		EndIf
	Else
		DrawASCText(_c1 + _txt, _x, _y)
	EndIf
End Function

Function HandleButton(_Max:Int)
	If KeyHit(KEY_UP) Then
		MenuPoint = (MenuPoint + _Max - 1) Mod _Max
	ElseIf KeyHit(KEY_DOWN) Then
		MenuPoint = (MenuPoint + 1) Mod _Max
	EndIf
End Function

