﻿'SuperStrict

Type TDice
	Field dice:String
	Field times:Int, sites:Int, boni:Int
	Field AddList:String
	Field LastRoll:Int
	
	Method Roll:Int()
		Self.AddList = ""
		If Self.times = 0 Or Self.sites = 0 Then Return Self.boni
		
		Local sum:Int, list:String
		For Local i:Int = 0 Until Self.times
			Local n:Int = Rand(1, Self.sites)
			sum:+n
			If Self.times > 1 Then list:+n + "+"
		Next
		If Self.times > 1 Then list = list[..list.length - 1]
		sum:+Self.boni
		If sum < 1 Then sum = 1
		
		If Self.boni < 0 Then
			list:+String(Self.boni)
		ElseIf Self.boni > 0 Then
			list:+"+" + Self.boni
		EndIf
		
		Self.AddList = list
		Self.LastRoll = sum
		Return sum
	End Method
	
	Method Percent:Int()
		Return (Rand(1, 100) < Self.LastRoll)
	End Method
	
	Method AddPercent(_add:Int)
		Self.LastRoll:+_add
		If Self.LastRoll > 100 Then Self.LastRoll = 100
	End Method
	
	Method SetBonus(_addTimes:Int, _addBoni:Int, _xTimes:Int = 1, _xBoni:Int = 1)
		Self.times:*_xTimes
		Self.boni:*_xBoni
		Self.times:+_addTimes
		Self.boni:+_addBoni
		Self.dice = Self.times + "d" + Self.sites
		If Self.boni < 0 Then
			Self.dice:+String(Self.boni)
		ElseIf Self.boni > 0 Then
			Self.dice:+"+" + Self.boni
		EndIf		
	End Method
	
	Function Create:TDice(_dice:String)
		_dice = _dice.Replace(" ", "").ToLower()
		
		Local D:TDice = New TDice
		D.dice = _dice
		
		If _dice.Find("+") > - 1 Then
			Local tmp:String[] = _dice.Split("+")
			_dice = tmp[0]
			D.boni = Int(tmp[1])
		ElseIf _dice.Find("-") > - 1 Then
			Local tmp:String[] = _dice.Split("-")
			_dice = tmp[0]
			D.boni = -Int(tmp[1])
		End If
		
		If _dice.Find("d") > - 1 Then
			Local tmp:String[] = _dice.Split("d")
			D.times = Int(tmp[0])
			D.sites = Int(tmp[1])
			If D.times = 0 Or D.sites = 0 Then
				If D.boni < 1 Then D.boni = 1
			EndIf
		EndIf
		
		Return D
	EndFunction
	
	Function PercentRoll:Int(N:Int)
		N = LimitInt(N, 1, 100)
		Return (Rand(1, 100) < N)
	EndFunction
	
	Method Copy:TDice()
		Return TDice.Create(Self.dice)
	End Method
	
End Type

Rem
	Wird nicht mehr benutzt, ist aber ein netter Prototyp
	um ein Würfel-Befehl zu zerlegen.
Endrem
Function RollDice:String[] (_dice:String)
	Local out:String[2], times:Int, sites:Int, boni:Int
	_dice = _dice.Replace(" ", "").ToLower()
	
	'Print("-----")
	'Print("Würfle: " + _dice)
	
	If _dice.Find("+") > - 1 Then
		Local tmp:String[] = _dice.Split("+")
		_dice = tmp[0]
		boni = Int(tmp[1])
	ElseIf _dice.Find("-") > - 1 Then
		Local tmp:String[] = _dice.Split("-")
		_dice = tmp[0]
		boni = -Int(tmp[1])
	End If
	out[0] = boni
	
	'Print("Boni: " + boni)
	'Print("Würfle: " + _dice)
	
	If _dice.Find("d") > - 1 Then
		Local tmp:String[] = _dice.Split("d")
		times = Int(tmp[0])
		sites = Int(tmp[1])
		If times = 0 Or sites = 0 Then Return out
	Else	
		Return out
	EndIf
	
	'Print(times + " x " + sites)
	
	Local sum:Int, list:String
	For Local i:Int = 0 Until times
		Local n:Int = Rand(1, sites)
		sum:+n
		If times > 1 Then list:+n + "+"
	Next
	If times > 1 Then list = list[..list.length - 1]
	sum:+boni
	If sum < 1 Then sum = 1
	
	If boni < 0 Then
		list:+String(boni)
	ElseIf boni > 0 Then
		list:+"+" + boni
	EndIf
	
	'Print(list + " = " + sum)

	out[0] = sum
	out[1] = list
	
	Return out
	
End Function
