﻿SuperStrict

Const TileSize:Int = 24
Global gfx_w:Int = TileSize * 32, gfx_h:Int = TileSize * 24	'* 768x576

AppTitle = "Unit42"
Graphics(gfx_w, gfx_h)
Local FrameTimer:TTimer = TTimer.Create(60)
Global Ascii:TImage = LoadAnimImage("../../Data/gfx/asciix" + TileSize + ".png", TileSize, TileSize, 0, 256, 0)

Include "../Dices.bmx"
Include "../PlayerClass.bmx"
Include "../WeaponClass.bmx"
Include "../EnemyClass.bmx"
Include "../Level.bmx"
Include "../Tiles.bmx"
Include "../AscText.bmx"
Include "../Misc.bmx"
Include "../InfoText.bmx"

TEnemyClass.Create("../../Data/enemys/Zombie.txt")
TEnemyClass.Create("../../Data/enemys/Hund.txt")
TEnemyClass.Create("../../Data/enemys/Schlange.txt")
TEnemyClass.Create("../../Data/enemys/Mutant.txt")
TEnemyClass.Create("../../Data/enemys/Zivilist.txt")

TTileCLass.Load("../../Data/tiles/tiles.txt")

Local FilePath:String '= RequestFile("Wähle Karte", "42", False, CurrentDir() + "/../../Data/level/")
Local MissionPath:String = "STD"
Map = T42Map.Create()

Local AktTile:Int, AktSymbol:Int, AktModus:Int

Repeat
	Cls
	
	If KeyHit(KEY_L) Then
		FilePath = RequestFile("Wähle Karte", "Unit42 Maps:42", False, CurrentDir() + "/../../Data/level/")
		If FilePath <> "" Then
			If FileType(FilePath) = 1 Then
				Map = T42Map.Load(FilePath)
			End If
			FlushKeys()
		EndIf
	ElseIf KeyHit(KEY_S) Then
		FilePath = RequestFile("Wähle Karte", "Unit42 Maps:42", True, CurrentDir() + "/../../Data/level/")
		If FilePath <> "" Then
			T42Map.Save(Map, FilePath, MissionPath)
			FlushKeys()
		EndIf
	EndIf
	
	If KeyHit(KEY_NUM0) Then AktModus:~1;AktTile = 0;AktSymbol = 0

	If AktModus = 0 Then
		If KeyHit(KEY_NUM2) Then
			AktTile = (AktTile + 1) Mod TTileCLass.Tiles.Length
			AktSymbol = 0
		ElseIf KeyHit(KEY_NUM8) Then
			AktTile = (AktTile + TTileCLass.Tiles.Length - 1) Mod TTileCLass.Tiles.Length
			AktSymbol = 0
		EndIf
		
		If KeyHit(KEY_NUM6) Then
			AktSymbol = (AktSymbol + 1) Mod TTileCLass.Tiles[AktTile].Symbols.Length
		ElseIf KeyHit(KEY_NUM4) Then
			AktSymbol = (AktSymbol + TTileCLass.Tiles[AktTile].Symbols.Length - 1) Mod TTileCLass.Tiles[AktTile].Symbols.Length
		EndIf
	Else
		If KeyHit(KEY_NUM2) Then
			AktTile = (AktTile + 1) Mod TTileClass.Enemys.Length
			AktSymbol = 0
		ElseIf KeyHit(KEY_NUM8) Then
			AktTile = (AktTile + TTileClass.Enemys.Length - 1) Mod TTileClass.Enemys.Length
			AktSymbol = 0
		EndIf
		
		If KeyHit(KEY_NUM6) Then
			AktSymbol = (AktSymbol + 1) Mod TTileClass.Enemys[AktTile].Symbols.Length
		ElseIf KeyHit(KEY_NUM4) Then
			AktSymbol = (AktSymbol + TTileClass.Enemys[AktTile].Symbols.Length - 1) Mod TTileClass.Enemys[AktTile].Symbols.Length
		EndIf
	EndIf
	
	If Map <> Null Then
		For Local y:Int = 0 Until Map.YSize
			For Local x:Int = 0 Until Map.XSize
				ASC_Color(Map.Map[x, y].Color & $F)
				DrawImage(Ascii, x * TileSize, y * TileSize, $DB)
				ASC_Color((Map.Map[x, y].Color & $F0) / $10)
				DrawImage(Ascii, x * TileSize, y * TileSize, Map.Map[x, y].Symbol)
				
				If Map.EMap[x, y] <> Null Then
					SetScale(0.5, 0.5)
						ASC_Color(Map.EMap[x, y].Color & $F)
						DrawImage(Ascii, x * TileSize, y * TileSize, $DB)
						ASC_Color((Map.EMap[x, y].Color & $F0) / $10)
						DrawImage(Ascii, x * TileSize, y * TileSize, Map.EMap[x, y].Symbol)
					SetScale(1, 1)
				EndIf
			Next
		Next
		
		If KeyHit(KEY_C) Then
			For Local y:Int = 0 Until Map.YSize
				For Local x:Int = 0 Until Map.XSize
					Map.Map[x, y] = TTile.Create(TTileClass.Tiles[AktTile])
					Map.Map[x, y].Symbol = TTileClass.Tiles[AktTile].Symbols[AktSymbol]
					Map.EMap[x, y] = Null
				Next
			Next
		EndIf
		
		If KeyHit(KEY_M) Then
			Notify("Benutze gerade " + StripDir(MissionPath))
			MissionPath = RequestFile("Wähle Missionstext", "Textfiles:txt", False, CurrentDir() + "/../../Data/txt/")
			If FileType(MissionPath) = 0 Then MissionPath = "STD"
			Notify("Benutze jetzt " + StripDir(MissionPath))
		EndIf
		
		If KeyHit(KEY_T) Then
			If MissionPath <> "STD" Then
				DisplayText(MissionPath)
			Else
				If FilePath <> "" Then
					DisplayText(StripExt(FilePath) + ".txt")
				End If
			EndIf
		End If
		
		If AktModus = 0 Then
			If MouseDown(1) Then
				Local x:Int = LimitInt(MouseX() / TileSize, 0, Map.XSize - 1)
				Local y:Int = LimitInt(MouseY() / TileSize, 0, Map.YSize - 1)
				Map.Map[x, y] = TTile.Create(TTileCLass.Tiles[AktTile])
				Map.Map[x, y].Symbol = TTileCLass.Tiles[AktTile].Symbols[AktSymbol]
			ElseIf MouseHit(2) Then
				Local x:Int = LimitInt(MouseX() / TileSize, 0, Map.XSize - 1)
				Local y:Int = LimitInt(MouseY() / TileSize, 0, Map.YSize - 1)
				
				For Local i:Int = 0 Until TTileCLass.Tiles.Length
					If Map.Map[x, y].Class = TTileClass.Tiles[i] Then AktTile = i
				Next
				For Local i:Int = 0 Until TTileCLass.Tiles[AktTile].Symbols.Length
					If Map.Map[x, y].Symbol = TTileCLass.Tiles[AktTile].Symbols[i] Then AktSymbol = i
				Next	
			EndIf
		Else
			If MouseDown(1) Then
				Local x:Int = LimitInt(MouseX() / TileSize, 0, Map.XSize - 1)
				Local y:Int = LimitInt(MouseY() / TileSize, 0, Map.YSize - 1)
				'If Map.Map[x, y].Class.Special = 0 Then
					Map.EMap[x, y] = TEnemyClass.GetClass(TTileClass.Enemys[AktTile].Name)
					Map.EMap[x, y].Symbol = TTileClass.Enemys[AktTile].Symbols[0]
				'EndIf
			ElseIf MouseDown(2) Then
				Local x:Int = LimitInt(MouseX() / TileSize, 0, Map.XSize - 1)
				Local y:Int = LimitInt(MouseY() / TileSize, 0, Map.YSize - 1)
				
				Map.EMap[x, y] = Null

			EndIf
		EndIf
	EndIf
	
	DrawASCText("{0F}M{F0}ission{0F}t{F0}ext", 0, 22)
	DrawASCText("{0F}L{F0}oad{0F}S{F0}ave{0F}C{F0}lean", 0, 23)
	DrawASCText("NumPad {0F}8{F0},{0F}2{F0},{0F}4{F0},{0F}6{F0},{0F}0{F0}", 16, 23)
	
	Local c:String, s:String, n:String
	If AktModus = 0 Then
		c = MakeColor(TTileClass.Tiles[AktTile].Color)
		s = MakeSymbol(TTileClass.Tiles[AktTile].Symbols[AktSymbol])
		n =	TTileCLass.Tiles[AktTile].Name
	Else
		c = MakeColor(TTileClass.Enemys[AktTile].Color)
		s = MakeSymbol(TTileClass.Enemys[AktTile].Symbols[AktSymbol])
		n = TTileClass.Enemys[AktTile].Name
	EndIf
	DrawASCText(c + s + "{F0} " + n, 16, 22)
	
	Flip(0)
	FrameTimer.Wait()
	
	If AppTerminate() Or KeyHit(KEY_ESCAPE) Then
		Local ok:Int = Confirm("Ungespeichertes geht verloren!~n~nWirklich Beenden?", True)
		If ok = True Then End
	EndIf
Forever
