﻿Rem
	Zombies sollten Zivilisten Anstecken und Schlangen giftig sein,
	aber das passte nicht mehr ins Budget... Stattdessen bewegen
	sich die Gegener unterschiedlich wahrscheinlich auf einen zu. 
	Keine überragene Intelligenz, aber immerhin.
Endrem

Type TEnemyClass
	Field name:String
	Field Symbol:Int
	Field Color:Int
	Field hp:TDice
	Field wpns:String[]
	
	Field MoveRND:Int, MoveTarget:Int
	
	Global List:TList = New TList

	Method New()
		List.AddLast(Self)
	End Method
	
	Function Create:TEnemyClass(_Path:String)
		Local file:TStream = ReadFile(_path)
		If file Then
			Local E:TEnemyClass = New TEnemyClass
			E.Name = file.ReadLine()
			E.Symbol = Int(file.ReadLine())
			E.Color = Int(file.ReadLine())
			E.hp = TDice.Create(file.ReadLine())
			E.wpns = file.ReadLine().Split(";")
			Local s:String[] = file.ReadLine().Split(";")
			E.MoveRND = Int(s[0])
			E.MoveTarget = Int(s[1])
			file.Close()
			Return E
		Else
			RuntimeError("~nTWeaponClass~nCreate() no~n" + StripDir(_Path))
		EndIf
	EndFunction
	
	Function GetClass:TEnemyClass(_name:String)
		For Local E:TEnemyClass = EachIn TEnemyClass.List
			If E.name = _name Then Return E
		Next
		Return Null
	End Function
	
End Type

Type TEnemy
	Field Class:TEnemyClass
	Field hp:Int
	Field idle:Int
	
	Field Weapon:TWeapon
	Field Target:TPlayer
	
	Field x:Int, y:Int

	Global List:TList = New TList

	Method New()
		List.AddLast(Self)
	End Method
	
	Method Draw()
		If Map.LightMap[Self.x, Self.y] <> 2 Then Return
		ASC_Color(Self.Class.Color & $F)
		DrawImage(Ascii, Self.x * TileSize, Self.y * TileSize, $DB)
		ASC_Color((Self.Class.Color & $F0) / $10)
		DrawImage(Ascii, Self.x * TileSize, Self.y * TileSize, Self.Class.Symbol)
	EndMethod
	
	Function DrawAll()
		For Local e:TEnemy = EachIn TEnemy.List
			e.Draw()
		Next
	EndFunction
	
	Function Update()
		For Local e:TEnemy = EachIn TEnemy.List
			If e.hp <= 0 Then TEnemy.List.Remove(e) ; Continue
			e.FindTarget()
			If e.AttackPlayer() Then Continue
			e.Move()
		Next	
	EndFunction
	
	Method FindTarget()
		'If Self.Target <> Null Then Return
		Local _x:Int = Self.x
		Local _y:Int = Self.y
		Local _r:Int = 3 '* Sichtradius
		For Local i:Int = -_r To _r
			If Self.LOS(_x, _y, _x - _r, _y + i) Then Return
			If Self.LOS(_x, _y, _x + _r, _y + i) Then Return
			If Self.LOS(_x, _y, _x + i, _y - _r) Then Return
			If Self.LOS(_x, _y, _x + i, _y + _r) Then Return
		Next
		Self.Target = Null
	EndMethod
	
	Method LOS:Int(x0:Int, y0:Int, x1:Int, y1:Int)
		Local dx:Int = Abs(x1 - x0)
		Local dy:Int = Abs(y1 - y0)
		Local sx:Int, sy:Int, err:Int, e2:Int
		If x0 < x1 Then sx = 1 Else sx = -1
		If y0 < y1 Then sy = 1 Else sy = -1
		err = dx - dy
		
		Repeat
			Local xc:Int = LimitInt(x0, 0, T42Map.XSize - 1)
			Local yc:Int = LimitInt(y0, 0, T42Map.YSize - 1)
			
			If Player.x = xc And Player.y = yc Then
				If Self.idle = True And TDice.PercentRoll(Player.Tarn) Then
					Return True
				Else
					Self.Target = Player
					Self.idle = True
					Return True
				EndIf
			EndIf
			If Map.Map[xc, yc].Special > 0 Then Exit

			If x0 = x1 And y0 = y1 Exit
			
		    e2 = 3 * err
		    If e2 > - dy Then
			    err = err - dy
			    x0 = x0 + sx
		    EndIf
			If e2 < dx Then
			    err = err + dx
			    y0 = y0 + sy
		    EndIf
		Forever
	EndMethod
	
	Method AttackPlayer:Int()
		If Self.Target = Null Then Return False	'* Kein Ziel...
		If Self.Weapon = Null Then Return False	'* Keine Waffe...
		If Self.Weapon.Class.mgz_n = -1 And DistInt(Self.x, Self.y, Player.x, Player.y) > 1 Then Return False '* Nahkampfs-Waffe und nicht nah genug!
		If Self.Weapon.Reload() = 1 Then
			'TInfoText.Add("{20}" + Self.Class.name + " lädt nach...")
			Return False
		EndIf
		If TDice.PercentRoll(Player.eva) Then
			TInfoText.Add("{E0}Du weichst " + Self.Class.name + " aus!")
		Else
			Player.hp:-Self.Weapon.dmg.Roll()
			Local s:String
			If Self.Weapon.dmg.AddList.Length Then s = " = "
			TInfoText.Add("{C0}" + Self.Class.name + " trifft! " + Self.Weapon.dmg.AddList + s + Self.Weapon.dmg.LastRoll+"DMG")
		End If
	EndMethod
	
	Method Move()
		If Self.Target <> Null Then
		
			If TDice.PercentRoll(Self.Class.MoveTarget) Then
				Local nx:Int = Self.x + Sgn(Self.Target.x - Self.x)
				Local ny:Int = Self.y + Sgn(Self.Target.y - Self.y)
				If nx < 0 Or nx >= Map.XSize Then Return
				If ny < 0 Or ny >= Map.YSize Then Return
				If nx = Self.Target.x And ny = Self.Target.y Then Return
				If Map.Map[nx, ny].Special = 0 Then
					Self.x = nx
					Self.y = ny
					Return
				EndIf
			EndIf
			
		ElseIf TDice.PercentRoll(Self.Class.MoveRND) Then '* Zufällige Bewegung
			Local nx:Int = Self.x + Rand(-1, 1)
			Local ny:Int = Self.y + Rand(-1, 1)
			If nx < 0 Or nx >= Map.XSize Then Return
			If ny < 0 Or ny >= Map.YSize Then Return
			If Map.Map[nx, ny].Special = 0 Then
				Self.x = nx
				Self.y = ny
			EndIf
		EndIf
		
	EndMethod

	Function Create:TEnemy(_Class:TEnemyClass, _x:Int, _y:Int)
		Local E:TEnemy = New TEnemy
		E.Class = _Class
		E.hp = _Class.hp.Roll()
		E.idle = True
		E.x = _x
		E.y = _y
		E.Weapon = TWeapon.Create(TWeaponClass.GetClass(_Class.wpns[Rand(0, _Class.wpns.Length - 1)]))
		Return E
	End Function

End Type