﻿Rem
	Ein Level-Subordner hat das Format XX_YY_ZZ_N
	XX = Nummer - Wichtig für die richtige Ordnung der Level
	YY/ZZ = Farbe&Aktive Farbe im Menü
	N = Beliebig langer Name 
Endrem

Type TLevel
	Field Path:String
	Field Name:String
	Field Color1:String, Color2:String
	Field WinPath:String, LoosePath:String
	
	Global List:TList = New TList
	Global NR:Int
	
	Function Load(_Path:String)
		Local dir:Int = ReadDir(_Path)
		If dir = 0 Then RuntimeError("TLevel~nLoad~nBad Path!~n~q" + _Path + "~q")
		
		Repeat
			Local f:String = NextFile(dir)
			If f = "" Exit
			If f = "." Or f = ".." Continue
			If FileType(_Path + f) = 2 Then
				Local data:String[] = f.Split("_")
				If data.Length = 4 Then
					Local L:TLevel = New TLevel
					L.Path = _Path + f + "/"
					L.WinPath = L.Path + "Win.txt"
					L.LoosePath = L.Path + "Loose.txt"
					L.Color1 = "{" + data[1] + "}"
					L.Color2 = "{" + data[2] + "}"
					L.Name = data[3]
					TLevel.List.AddLast(L)
				EndIf
			EndIf
		Forever

		CloseDir(dir)
	End Function
	
	Method LoadNextLevel()
		TEnemy.List.Clear()
		TInfoText.Clear()
		Local s:String = Self.Path + "Level_" + TLevel.NR + ".42"
		If FileType(s) = 1 Then
			Map = T42Map.Load(s)
			Map.ComeToLifeBySatansUnholyPower()
			Rem
				Der Missionstext ist kurz und lässt sich für die lesefaulen
				eigentlich problemlos überspringen, aber vll. wird die Welt
				mit etwas drum herum interessanter.
			Endrem
			If Map.MissionPath = "STD" Then
				DisplayText(Self.Path + "Level_" + TLevel.NR + ".txt", "Weiter")
			Else
				DisplayText(Map.MissionPath, "Weiter")
			EndIf
			If Self.Name <> "Tutorial" And TLevel.NR > 1 Then
				Player.HP_Max:+Player.Class.reg.roll()
				Player.HP:+Player.Class.reg.LastRoll
				GameState = GS_UpgradeMenu
			EndIf
			Player.Regenerate(True)
			TLevel.NR:+1
		Else
			rem
				Es gibt keine weiteren Level mehr: Spieler hat gewonnen!
				Glückwünsche / Outro Anzeigen -> Hauptmenü
			endrem
			DisplayText(Self.WinPath)
			If Self.Name = "Tutorial" Then
				Rem
					Super-Spezial Ausnahme um nach dem Tutorial
					mit dem Charakter die Kampagne spielen zu können.
				Endrem
				Player.HP = Player.HP_Max
				Player.SetClass(Player.Class)
				GameState = GS_LevelMenu
				MenuPoint = 1
			Else
				GameState = GS_Menu
			End If
			
		EndIf
		FlushKeys()
	End Method

End Type
