﻿Rem
	Hier gibt's nicht viel zu sagen, nur
	für die Feststellung "Nahkampfwaffe" hätte
	sich eine extra-variable schon gelohnt.
	Hängt aber auch mit dem nicht-vorhanden-sein
	von anderen Items zusammen.
	
	Keine Befriedigung des Sammlerinstinkts... mist.
Endrem

Type TWeaponClass
	Field name:String
	Field dmg_dice:TDice
	Field mgz:Int '* Kugeln per Magazin
	Field mgz_n:Int '* Anzahl Magazine
	
	Global List:TList = New TList
	
	Method New()
		List.AddLast(Self)
	End Method
	
	Function Create:TWeaponClass(_Path:String)
		Local file:TStream = ReadFile(_path)
		If file Then
			Local W:TWeaponClass = New TWeaponClass
			W.Name = file.ReadLine()
			W.dmg_dice = TDice.Create(file.ReadLine())
			W.mgz = Int(file.ReadLine())
			W.mgz_n = Int(file.ReadLine())
			file.Close()
			Return W
		Else
			RuntimeError("~nTWeaponClass~nCreate() no~n" + StripDir(_Path))
		EndIf
	EndFunction
	
	Function GetClass:TWeaponClass(_name:String)
		For Local W:TWeaponClass = EachIn TWeaponClass.List
			If W.name = _name Then Return W
		Next
		RuntimeError("TWeaponClass: no~q" + _name + "~q Class")
	End Function
	
End Type

Type TWeapon
	Field Class:TWeaponClass
	Field Mag:Int '* Aktuelles Magazin
	Field Ammo:Int '* Kugeln insgesammt
	Field dmg:TDice
	
	Function Create:TWeapon(_Class:TWeaponClass, _double:Int = False)
		Local W:TWeapon = New TWeapon
		W.Class = _Class
		If _Class.mgz > 0 Then W.Ammo = _Class.mgz * _Class.mgz_n
		W.Reload()
		W.dmg = _Class.dmg_dice.Copy()
		If _double Then
			W.dmg.SetBonus(0, 0, 2, 1)
		EndIf
		Return W
	End Function
	
	Method FireOn(E:Tenemy, msg:Int = False)
		If Self.Class.mgz_n = -1 Then
			If TDice.PercentRoll(Player.Ziel) Then
				E.HP:-Self.dmg.roll()
				If msg Then
					Local s:String
					If Self.dmg.AddList.length Then s = " = "
					TInfoText.Add("Du triffst! {0F}DMG " + Self.dmg.AddList + s + Self.dmg.LastRoll)
				EndIf
			Else
				If msg Then TInfoText.Add("Du verfehlst " + E.Class.name + "!")
			EndIf
		Else
			If Self.Mag > 0 Then
				Self.Mag:-1
				If TDice.PercentRoll(Player.Ziel) Then
					E.HP:-Self.dmg.roll()
					If msg Then
						Local s:String
						If Self.dmg.AddList.length Then s = " = "
						TInfoText.Add("Du triffst! {0F}DMG " + Self.dmg.AddList + s + Self.dmg.LastRoll)
					EndIf
				Else
					If msg Then TInfoText.Add("Du verfehlst " + E.Class.name + "!")
				EndIf
			Else
				If msg Then TInfoText.Add("{20}*klick*")
			End If
		End If
	End Method
	
	Method Reload:Int(msg:Int = False)
		'* Kein Magazin, kein Reload
		If Self.Class.mgz_n < 1 Then
			If msg Then TInfoText.Add("Keine Munition!")
			Return - 1
		EndIf
		Local diff:Int = Self.Class.mgz - Self.Mag
		'* Kein Reload nötig
		If diff = 0 Then
			If msg Then TInfoText.Add("Nicht nötig")
			Return 0
		EndIf
		'* Nicht mehr Kugeln nehmen, als noch übrig sind
		diff = Min(diff, Self.Ammo)
		Self.Ammo:-diff
		Self.Mag:+diff
		If msg Then TInfoText.Add("Lade " + diff + " Kugeln nach!")
		Return 1
	EndMethod
		
End Type
