﻿SuperStrict

Rem
	Würfelspiel: 
		- Würfel muss nicht dar gestellt werden
		- ein einfaches Rnd genügt
		
	Ich verwende also Pen&Paper-like Würfel/Regeln.
	
	Player & Enemies sollten eigentlich der gleiche Type sein
	oder wenigstens	abgeleitet sein.
	Enemies sollten auch in der Karte abgespeichert werden - 
	redundant, aber sehr viel einfacher für Beleuchtung
	und Zielberechnung usw.
	
	Charakter-Eigenschaften:
		Jeweils Max. 100, so 4d20
		wäre z.b: 19+7+20+17 = 63

		- Zielen (Wahrscheinlichkeit zu treffen)
		- Schleichen (Wahrsch. unbemerkt zu bleiben)
		- Ausweichen (Wahrsch. einem Angriff aus zu weichen)
		- Regeneration:	Alle 10 Schritte/Aktionen			
EndRem

Const TileSize:Int = 24
Global gfx_w:Int = TileSize * 32, gfx_h:Int = TileSize * 24	'* 768x576

AppTitle = "Unit42"
Graphics(gfx_w, gfx_h)
SeedRnd(MilliSecs()) '* <-- Total unwichtig. Gar nicht beachten.
HideMouse()
Local FrameTimer:TTimer = TTimer.Create(60)
Global Ascii:TImage = LoadAnimImage("Data/gfx/asciix" + TileSize + ".png", TileSize, TileSize, 0, 256, 0)
Global QR_Code:TImage = LoadImage("Data/gfx/QR.png") ;MidHandleImage(QR_Code)

Include "Include/Dices.bmx"
Include "Include/AscText.bmx"
Include "Include/PlayerClass.bmx"
Include "Include/WeaponClass.bmx"
Include "Include/EnemyClass.bmx"
Include "Include/Tiles.bmx"
Include "Include/Level.bmx"
Include "Include/Misc.bmx"
Include "Include/InfoText.bmx"

Rem
	Alles, alles laden... ginge sicher noch besser,
	wenn die Ordner automatisch ausgelesen würden...
Endrem
TLevel.Load(CurrentDir() + "/Data/level/")

TEnemyClass.Create("Data/enemys/Zombie.txt")
TEnemyClass.Create("Data/enemys/Hund.txt")
TEnemyClass.Create("Data/enemys/Schlange.txt")
TEnemyClass.Create("Data/enemys/Mutant.txt")
TEnemyClass.Create("Data/enemys/Zivilist.txt")

TTileClass.Load("Data/tiles/tiles.txt")

TWeaponClass.Create("Data/weapons/Messer.txt")
TWeaponClass.Create("Data/weapons/Pistole.txt")
TWeaponClass.Create("Data/weapons/Shotgun.txt")
TWeaponClass.Create("Data/weapons/Gewehr.txt")

TWeaponClass.Create("Data/weapons/HundeBiss.txt")
TWeaponClass.Create("Data/weapons/SchlangenBiss.txt")
TWeaponClass.Create("Data/weapons/ZombieBiss.txt")

Global PlayerClass:TPlayerClass[] = [TPlayerClass.Create("Data/classes/Marine.txt"),  ..
									TPlayerClass.Create("Data/classes/Scout.txt"),  ..
									TPlayerClass.Create("Data/classes/Sniper.txt"),  ..
									TPlayerClass.Create("Data/classes/Franz.txt")]
Global QRC:Int
Const Story_Path:String = "Data/txt/Story.txt"
Const Control_Path:String = "Data/txt/Controls.txt"
Const Name_Path:String = "Data/txt/Names.txt"
MenuPoint = 1


?Debug
	Notify("Please build the Release Version!~nDebug build contains ugly debug graphics.", True)
	End
?


Repeat
	Cls
	
	Select GameState
		Case GS_Menu; Run_Menu()
		Case GS_CharMenu; Run_CharMenu()
		Case GS_CharMenu2; Run_CharMenu2()
		Case GS_LevelMenu; Run_LevelMenu()
		Case GS_Play; Run_Play()
		Case GS_UpgradeMenu; Run_UpgradeMenu()
	End Select
	
	Flip(0)
	FrameTimer.Wait()
Until AppTerminate()
End

Function Run_Menu()
	DrawASCText("{06}Unit{60}42", 13, 1)
	
	If Button("Spielen", 13, 6, 0, "{0A}", "{A0}") = 1 Then GameState = GS_CharMenu
	If Button("Steuerung", 13, 8, 1, "{09}", "{90}") = 1 Then
		DisplayText(Control_Path, "{B0}[1a]Zurück")
		'DisplayText("Data\level\02_08_E0_Kampagne\win.txt", "{B0}[1a]Weiter")
	EndIf
	If Button("Story", 13, 10, 2, "{07}", "{70}") = 1 Then DisplayText(Story_Path, "{70}[1a]Zurück")
	If Button("Ende", 13, 12, 3, "{0C}", "{C0}") = 1 Then End
	If QRC <> 1000 Then QRC:+1;SetColor(0, 0, 0) Else SetColor(255, 255, 255) ;DrawImage(QR_Code, gfx_w *.85, gfx_h *.8)
	HandleButton(4)
EndFunction


Function Run_Play()
	Global Update:Int = True, LookAround:Int = False, FireOn:Int = False, Death:Int = False
	Local Action:Int = False
	
	If KeyHit(KEY_F1) Then DisplayText(Control_Path, "{B0}[1a]Zurück")
	
	If Update Then
		Update = False
		Map.AndGodSaidLetThereBeLight(Player.x, Player.y, 3)
		Player.FindTargets()
	EndIf
		
	Map.Draw()
	TEnemy.DrawAll()
	Player.Draw()
	TInfoText.Update()
	
	
	If LookAround Then LookAround = Player.Look() ; Return
	If FireOn Then
		FireOn = Player.Fire()
		Select FireOn
			Case - True
				Action = True
				FireOn = False
			Case True
				Return
		EndSelect
	EndIf
	
	If Not(Death) Then
		If Not(Action) Then
			If KeyHit(KEY_X) Then
				Player.Look(True)
				LookAround = True
				FlushKeys()
				Player.MSG = ""
			ElseIf KeyHit(KEY_F) Or KeyHit(KEY_SPACE) Then
				FireOn = True
				FlushKeys()
				Player.MSG = ""
			EndIf
		EndIf
		
		If Not(Action) Then Action = Player.Move()
		If Not(Action) Then Action = Player.ReLoad()
		If Not(Action) Then Action = Player.SwitchWPN()
		
		If Player.CheckLoose() Then Death = True; TInfoText.Add("{6F}Du bist gestorben!")
	EndIf

	'If KeyHit(KEY_F10) Then Level.LoadNextLevel() ;Return
	
	'* Enemy-Turn
	If Action Then
		Update = True
		Player.Regenerate()
		TEnemy.Update()
	EndIf
	
	If Death = True And TInfoText.List.Count() = 0 Then
		DisplayText(Level.LoosePath, "Ende")
		TEnemy.list.Clear()
		MenuPoint = 0
		Update = True
		LookAround = False
		FireOn = False
		Death = False
		GameState = GS_Menu
		FlushKeys()
		Return
	EndIf
	If Map.CheckWin() Then Level.LoadNextLevel() ;Return
	
	If KeyHit(KEY_ESCAPE) And Death = False Then
		If Confirm("Spiel wird ~~nicht~~ gespeicher!~n~nWillst du dem wirklich ein Ende machen?", True) Then
			TInfoText.Add("{35}Du schluckst eine Cyanidtablette")
			Death = True
		EndIf
	EndIf
End Function

Function Run_UpgradeMenu()
	Global Points:Int = 2
	Local tmp:String
	
	DrawASCText(MakeVGColor(Player.Color) + MakeSymbol(Player.Symbol) + " " + Player.Name + " " + Player.Class.name, 1, 1)

	If Player.wpn <> - 1 Then
		If Player.Weapon[0].Class.mgz_n <> - 1 Then tmp = "{F0} Mun: " + Player.Weapon[0].ammo
		DrawASCText(Player.Weapon[0].Class.name + " {06}" + Player.Weapon[0].dmg.dice + tmp, 1, 2)
		If Player.Weapon[1] <> Null Then
			tmp = ""
			If Player.Weapon[1].Class.mgz_n <> - 1 Then tmp = "{F0} Mun: " + Player.Weapon[1].ammo
			DrawASCText(Player.Weapon[1].Class.name + " {06}" + Player.Weapon[1].dmg.dice + tmp, 1, 3)
		EndIf
		DrawASCText("{0F}M{F0}unition anfordern", 1, 4)
		If Points <> 0 And KeyHit(KEY_M) Then
			If Player.Weapon[0].Class.mgz_n <> - 1 Then Player.Weapon[0].ammo:+20
			If Player.Weapon[1].Class.mgz_n <> - 1 Then Player.Weapon[1].ammo:+20
			Points:-1
		EndIf
	Else
		'* Extra-Wurst für die dämlichen Franzosen - die einzige Klasse, die ihren Schaden erhöhen kann!
		DrawASCText(Player.Weapon[0].Class.name + " {06}" + Player.Weapon[0].dmg.dice, 1, 2)
		DrawASCText("{0F}M{F0}esser schärfen", 1, 4)
		If Points <> 0 And KeyHit(KEY_M) Then
			If Player.Weapon[0].dmg.boni = Player.Weapon[0].dmg.sites Then
				Player.Weapon[0].dmg.SetBonus(1, -Player.Weapon[0].dmg.sites)
			Else
				Player.Weapon[0].dmg.SetBonus(0, 1)
			End If	
			Points:-1
		EndIf
	EndIf
	
	DrawASCText("Trefferpunkte: " + Player.GetHP(), 1, 6)
	DrawASCText("{0F}H{F0}eilen: {09}" + Player.Class.reg.dice, 1, 7)
	If Points <> 0 And KeyHit(KEY_H) Then Player.Regenerate(-1) ;Points:-1
	
	DrawASCText("Lernen: {09}" + Player.Class.lern.dice, 1, 9)
	DrawASCText("{0F}Z{F0}ielen:     {0E}" + Player.Ziel, 1, 10)
	If Points <> 0 And Player.Ziel < 95 And KeyHit(KEY_Z) Then
		Player.Ziel:+Player.Class.lern.Roll()
		Player.Ziel = LimitInt(Player.Ziel, 1, 95)
		Points:-1
	EndIf
	DrawASCText("{0F}S{F0}chleichen: {0E}" + Player.tarn, 1, 11)
	If Points <> 0 And Player.tarn < 95 And KeyHit(KEY_S) Then
		Player.tarn:+Player.Class.lern.Roll()
		Player.tarn = LimitInt(Player.tarn, 1, 95)
		Points:-1
	EndIf
	DrawASCText("{0F}A{F0}usweichen: {0E}" + Player.eva, 1, 12)
	If Points <> 0 And Player.eva < 95 And KeyHit(KEY_A) Then
		Player.eva:+Player.Class.lern.Roll()
		Player.eva = LimitInt(Player.eva, 1, 95)
		Points:-1
	EndIf
	
	Rem
		Nicht nur unlogisch, sondern auch total die Abzocke; 
		trifft es eine Wand, kennt man nur 1 zusätzliches tile...
		Aber darum geht es: Man präsentiert eine Wahl und der
		Spieler trifft sie. Jede runde Munition und Leben auffüllen
		wäre nur langweilig.
	Endrem
	DrawASCText("Nächstes Gebiet {0F}O{F0}bservieren", 1, 14)
	If Points <> 0 And KeyHit(KEY_O) Then
		Map.AndGodSaidLetThereBeLight(-1, -1, 4)
		Points:-1
	EndIf
	
	If Points = 0 Then
		DrawASCText("Alle Punkte verbraucht!", 1, 18)
	Else
		DrawASCText("Noch {09}" + Points + "{F0} Punkte", 1, 18)
	End If
	
	
	If Points = 0 Then
		DrawASCText("Drücke {0F}ENTER{F0} zum Weiterspielen", 1, 22)
		If KeyHit(KEY_RETURN) Then
			Points = 2
			TInfoText.Clear()
			GameState = GS_Play
			FlushKeys()
		EndIf
	EndIf

End Function

Function Run_CharMenu()
	DrawASCText("Wähle eine Klasse:", 1, 1)
	
	For Local i:Int = 0 Until PlayerClass.length
		Select Button(MakeSymbol(PlayerClass[i].Symbol), 5, 6 + i * 2, i, "{20}", "{F0}")
			Case 1
				Player.setClass(PlayerClass[i])
				Player.RollStats()
				MenuPoint = 0
				GameState = GS_CharMenu2
				FlushKeys()
			Case 2
				DrawASCText(PlayerClass[i].txt, 8, 5)
		End Select
	Next

	HandleButton(PlayerClass.length)
	
	If KeyHit(KEY_ESCAPE) Then MenuPoint = 0;GameState = GS_Menu
EndFunction

Function Run_CharMenu2()
	Global Names:String[] = LoadNames(Name_Path)
	Local tmp:String
	
	DrawASCText("Würfel eine {0F}F{F0}arbe: " + MakeVGColor(Player.Color) + MakeSymbol(Player.Symbol), 1, 1)
	If KeyHit(KEY_F) Or Player.Color = 0 Then Player.Color = $10 * (Rand(0, 11) + 4)
	
	'* Wozu einen Input schreiben, wenn es auch sooo viel Aufgaben-mäßiger geht?
	DrawASCText("Würfel einen {0F}N{F0}amen: " + MakeVGColor(Player.Color) + Player.Name, 1, 3)
	If KeyHit (KEY_N) Or Player.Name = "" Then Player.Name = Names[Rand(0, Names.Length - 1)]

	DrawASCText("Bewaffnung:", 1, 5)
	DrawASCText(Player.Weapon[0].Class.name + " {06}" + Player.Weapon[0].dmg.dice, 1, 6)
	If Player.Weapon[1] <> Null Then DrawASCText(Player.Weapon[1].Class.name + " {06}" + Player.Weapon[1].dmg.dice, 16, 6)
	
	DrawASCText("Würfel deine {0F}E{F0}igenschaften:", 1, 8)
	If KeyHit(KEY_E) Then Player.RollStats()
	
	DrawASCText("Trefferpunkte: {01}" + Player.Class.HP_dice.dice, 1, 10)
	tmp = "{20}" + Player.Class.HP_dice.AddList + " = {0E}" + Player.HP_Max
	DrawASCText(StringRepeat(" ", 35 - tmp.Length) + tmp, 1, 11)
	
	DrawASCText("Zielen: {01}" + Player.Class.Ziel.dice, 1, 12)
	tmp = "{20}" + Player.Class.Ziel.AddList + " = {0E}" + Player.Ziel
	DrawASCText(StringRepeat(" ", 35 - tmp.Length) + tmp, 1, 13)
	
	DrawASCText("Schleichen: {01}" + Player.Class.tarn.dice, 1, 14)
	tmp = "{20}" + Player.Class.tarn.AddList + " = {0E}" + Player.tarn
	DrawASCText(StringRepeat(" ", 35 - tmp.Length) + tmp, 1, 15)
	
	DrawASCText("Ausweichen: {01}" + Player.Class.eva.dice, 1, 16)
	tmp = "{20}" + Player.Class.eva.AddList + " = {0E}" + Player.eva
	DrawASCText(StringRepeat(" ", 35 - tmp.Length) + tmp, 1, 17)
	
	DrawASCText("Heilung: {01}" + Player.Class.reg.dice, 1, 18)
	DrawASCText("Lernen : {01}" + Player.Class.lern.dice, 1, 19)
	
	DrawASCText("{50}S{05}P{50}IELEN!", 12, 21)
	If KeyHit(KEY_P) Then GameState = GS_LevelMenu; FlushKeys()
	
	If KeyHit(KEY_ESCAPE) Then
		Player.UnSetClass()
		GameState = GS_CharMenu
	EndIf
End Function

Function Run_LevelMenu()
	DrawASCText("{06}Unit{60}42", 13, 1)
	
	Local i:Int = 0
	For Local L:TLevel = EachIn TLevel.List
		If Button(L.Name, 12, 6 + i * 2, i, L.Color1, L.Color2) = 1 Then
			MenuPoint = 0
			TLevel.NR = 1
			Level = L
			Level.LoadNextLevel()
			Player.MSG = ""
			GameState = GS_Play
			FlushKeys()
			Return
		EndIf
		i:+1
	Next

	If KeyHit(KEY_ESCAPE) Or Button("Zurück", 12, 6 + i * 2, TLevel.List.Count(), "{01}", "{F0}") = 1 Then
		Player.RollStats()
		MenuPoint = 0
		GameState = GS_CharMenu2
	EndIf
	
	HandleButton(TLevel.List.Count() + 1)	
End Function
